package OMBouncingBall
  model BouncingBall
    Modelica.Blocks.Interfaces.RealInput e(start=0.8) annotation(
      Placement(visible = true, transformation(origin = {-76, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-76, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealOutput y annotation(
      Placement(visible = true, transformation(origin = {86, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {86, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    import SI = Modelica.SIunits;
    SI.Length h;
    SI.Velocity v;
    parameter SI.Acceleration g = Modelica.Constants.g_n;
    parameter SI.Height h0 = 1.0;
  initial equation
    h = h0;
  equation
    v = der(h);
    der(v) = -g;
    y = h;
    when h < 0 then
      reinit(v, -e * pre(v));
    end when;
    annotation( Icon(graphics = {Line(origin = {-16.6524, 1.56586}, points = {{-73.7953, 75.8222}, {-49.7953, 47.8222}, {-31.7953, 3.8222}, {-17.7953, -84.1778}, {-3.79534, -0.1778}, {4.2047, 25.8222}, {12.2047, 39.8222}, {20.2047, 39.8222}, {30.2047, 25.8222}, {36.2047, -0.1778}, {52.2047, -84.1778}, {74.2047, 13.8222}, {74.2047, 15.8222}, {74.2047, 15.8222}, {74.2047, 15.8222}}), Ellipse(origin = {57, 25}, fillColor = {0, 0, 255}, fillPattern = FillPattern.Solid, extent = {{-25, 25}, {25, -25}}, endAngle = 360)}));
  end BouncingBall;

  model BouncingBallTest
  BouncingBall bouncingBall annotation(
      Placement(visible = true, transformation(origin = {18, -2.22045e-15}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step(height = -0.3, offset = 1, startTime = 1)  annotation(
      Placement(visible = true, transformation(origin = {-34, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(step.y, bouncingBall.e) annotation(
      Line(points = {{-22, 0}, {3, 0}}, color = {0, 0, 127}));
  annotation(
      experiment(StartTime = 0, StopTime = 3, Tolerance = 1e-6, Interval = 0.006));end BouncingBallTest;
  annotation(
    uses(Modelica(version = "3.2.3")));
end OMBouncingBall;